/* Sinus mit PWM erzeugen an P0.6  mit Amplitudeneinstellung am Poti */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
// in XMC1100-Lib.c definiert: #define periode 2550 fuer PWM-Frequenz ca. 1.5 kHz
uint8_t z;							// Zählvariable
uint16_t sinus []= {				// wegen Multiplikation unten 16Bit
		128,136,145,154,163,171,180,188,195,203,210,216,223,228,234,
				238,243,246,249,252,254,255,255,255,255,254,252,249,246,243,
				238,234,228,223,216,210,203,195,188,180,171,163,154,145,136,
				128,119,110,101,92,84,75,67,60,52,45,39,32,27,21,
				17,12,9,6,3,1,0,0,0,0,1,3,6,9,12,
				17,21,27,32,39,45,52,60,67,75,84,92,101,110,119};
uint16_t ampl;						// wegen Multiplikation unten 16Bit

int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe-> LEDs aus
  adc_init();
  pwm1_init();						// PWM Kanal 0 initialisieren
  pwm1_start_interrupt();			// Ausgabe starten
  while(1U)							// Endlosschleife, immer bei Controllern
  {
	 ampl = adc_in(0)>>4; 				// 8-Bit-wert von Poti links
	 //frequenz = adc_in(1<<4);			// 8-Bit-Wert von Poti rechts
  }//while
}//main

void CCU40_0_IRQHandler (void)
{
	if (z < 89) z++;  else z = 0;	// Tabelle abarbeiten
	//pwm1_duty_cycle (ampl*sinus[z]/255); 	// Sinus hat negativsten Wert immer bei 0, Offset verschieb sich nach oben mit steigender Amplitude
	pwm1_duty_cycle (127+ampl*(sinus[z]-127)/255);
	//-127 -> "nach unten" schieben, Werte werden auch negativ
	// Mit Amplitudewert multiplizieren, dann auf Größe max 255 normieren
	// und wieder um 127 nach oben oben verschieben (Offset des Sinus)
}
