/* Sinus mit PWM erzeugen an P0.6  mit Amplitudeneinstellung am Poti links
 * und Periodendauer am Poti rechts */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t z;							// Zählvariable
uint16_t sinus []= {				// wegen Multiplikation unten 16Bit
		128,136,145,154,163,171,180,188,195,203,210,216,223,228,234,
				238,243,246,249,252,254,255,255,255,255,254,252,249,246,243,
				238,234,228,223,216,210,203,195,188,180,171,163,154,145,136,
				128,119,110,101,92,84,75,67,60,52,45,39,32,27,21,
				17,12,9,6,3,1,0,0,0,0,1,3,6,9,12,
				17,21,27,32,39,45,52,60,67,75,84,92,101,110,119};
uint16_t ampl,periode;				// wegen Multiplikation unten 16Bit

int main(void)						// Hauptprogramm
{ delay_ms(500);					// Auf LC-Display-Bereitschaft warten
  lcd_init();
  lcd_setcursor ( 1,1 );     		// 1.Zeile, 1. Spalte
  lcd_print  ( "Amplitu:     links");
  lcd_setcursor ( 2,1 );     		// 2.Zeile, 1. Spalte
  lcd_print   ("Periode:     rechts");
  lcd_setcursor ( 3,1 );     		// 3.Zeile, 1. Spalte
  lcd_print   ("PWM an P0.6");
  lcd_setcursor ( 4,1 );     		// 4.Zeile, 1. Spalte
  lcd_print   ("R=1kOhm,C=1uF->Sinus");
  port_init(P0,OUTP);				// Port0 auf Ausgabe-> LEDs aus
  adc_init();						// Analog-Digital-Converter
  pwm1_init();						// PWM Kanal 0 initialisieren
  pwm1_start_interrupt();			// Ausgabe starten mit Interrupt nach jeder Periode
  while(1U)							// Endlosschleife, immer bei Controllern
  {
	 ampl = adc_in(0)>>4; 			// 8-Bit-wert von Poti links -> Amplitude
	 periode = adc_in(1)>>4;		// 8-Bit-Wert von Poti rechts -> Periodendauer
	 lcd_setcursor ( 1,10 );     	// 1.Zeile, 10. Spalte
	 lcd_byte      ( ampl  );       // Wert Poti -> Amplitude 0 ... 255
	 lcd_setcursor ( 2,10 );    	// 1.Zeile, 10. Spalte
	 lcd_byte      ( periode  );    // Wert Poti-> Periodendauer 0 ... 255
  }//while
}//main

void CCU40_0_IRQHandler (void)		// Interrupt-Service-Routine
{
	if (z < 89) z++;  else z = 0;	// Tabelle abarbeiten
	// Sinus hat negativsten Wert immer bei 0, Offset verschieb sich nach oben mit steigender Amplitude:
	//if (ampl<periode) pwm1_duty_cycle_period (ampl*sinus[z]/255,periode); // Amplitude ändert sich mit Periode
	pwm1_duty_cycle_period (ampl*sinus[z]*periode/255/255,periode);		// Amlitude und Periode unabhängig änderbar
	// Sinus hat Mittelwert immer bei 2,5V:
	// pwm1_duty_cycle_period (periode/2+ampl*(sinus[z]-127)*periode/255/255,periode);
	//-127 -> "nach unten" schieben, Werte werden auch negativ
	// mal Amplitudewert, dann auf Größe max 255 normieren und  mal periode/255 damit Amplitude sich mit mit Periode ändert
	// und wieder um periode/2 nach oben oben verschieben (Offset des Sinus)
}

