/* Sägezahnspannung (Rampe) mit PWM erzeugen an P0.6
 * für LED-Kennlinienschreiber, R=1kOhm, C=1µF an P0.6 */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t z;							// Zählvariable

int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe-> LEDs aus
  pwm1_init();						// PWM Kanal 0 initialisieren
  pwm1_start();						// Ausgabe starten
  while(1U)							// Endlosschleife, immer bei Controllern
  {
	  pwm1_duty_cycle(0);			// 0V ausgeben
	  delay_ms(100);				// warten bis Kondensator entladen
	  for (z=0; z<255;z++)			// Spannung 0...5V erhöhen
		  { pwm1_duty_cycle(z); 	// dazu PWM-Tastgrade ändern
		    delay_ms(1);			// legt Steilheit der Spannungsrampe fest
		  }
  }//while
}//main

